import codecs

import yaml

def collectdocs(shelf, args):
    """Looks for documentation in local repository clones and writes out
    a files that can be used to update the Documentation nodes in the
    Chrysoberyl data.

    """
    docdict = {}

    def collectdocs_it(source):
        for path in source.find_likely_documents():
            docdict.setdefault(source.name, []).append(path)

    shelf.foreach_specced_source(
        shelf.expand_docked_specs(args), collectdocs_it
    )

    output_filename = 'docs.yaml'
    with codecs.open(output_filename, 'w', 'utf-8') as file:
        file.write('# encoding: UTF-8\n')
        file.write('# AUTOMATICALLY GENERATED BY chrysoberyl.py\n')
        file.write(yaml.dump(docdict, Dumper=yaml.Dumper, default_flow_style=False))
